From 2dec4215e3bb959a03231de7019bfeaf60f799cf Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 26 2021 21:07:54 +0000
Subject: [PATCH 2199/2232] Include unsafe token in notional span of extern fn signatures


---

diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 13b5cd3..c1a06a2 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -204,6 +204,7 @@ impl ToTokens for Enum {
 impl ToTokens for ExternFn {
     fn to_tokens(&self, tokens: &mut TokenStream) {
         // Notional token range for error reporting purposes.
+        self.unsafety.to_tokens(tokens);
         self.sig.fn_token.to_tokens(tokens);
         self.semi_token.to_tokens(tokens);
     }
diff --git a/tests/ui/mut_return.stderr b/tests/ui/mut_return.stderr
index 27043d7..6b091d7 100644
--- a/tests/ui/mut_return.stderr
+++ b/tests/ui/mut_return.stderr
@@ -5,7 +5,7 @@ error: &mut return type is not allowed unless there is a &mut argument
   |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 
 error: &mut return type is not allowed unless there is a &mut argument
- --> $DIR/mut_return.rs:7:16
+ --> $DIR/mut_return.rs:7:9
   |
 7 |         unsafe fn g(t: &Thing) -> Pin<&mut CxxString>;
-  |                ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+  |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

